#!/usr/bin/env python
#
# This file is part of MathTown
# Author(s): Brittany Morgan and Valerie Carrizales, Girlstart
# Copyright 2008
#
# Source code is derived from Girlstart's Project IT Girl Game Templates:
# http://itgirl.dreamhosters.com/itgirlgames/, http://www.girlstart.org/itgirl
# See the credits file for image sources.
#
# MathTown is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# MathTown is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with MathTown.  If not, see <http://www.gnu.org/licenses/>.

import sys, pygame, random, os
from helpers import *
from Activities import *
pygame.init()

# Set up the window
windowsize = windowwidth, windowheight = 880, 522
screen = pygame.display.set_mode(windowsize)
area = screen.get_rect()
background,background_rect = load_image("bigtown.png")
game_over = False

# Set up the group of activities
activities = pygame.sprite.OrderedUpdates()
activities.add(Activity1((235,248),background,"store4.png","thumbs-up.png"))
activities.add(Activity2((425,350),background,"house4.png","thumbs-up.png"))
activities.add(Activity3((570,315),background,"school5.png","thumbs-up.png"))
activities.add(Activity4((565,170),background,"library building2.png","thumbs-up.png"))




# Start screen
start_game = False
while not start_game:
	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			sys.exit() # if the user closed the window, quit the game
		elif event.type == pygame.KEYDOWN: # if the user pressed a key
			start_game = True # start the game
		
	# Draw everything to the screen
	screen.blit(background, (0, 0))	# draw over everything on the screen now by re-drawing the background

	# Draw the instructions
	font = pygame.font.Font(None, 100)
	text = font.render("Welcome to MathTown!", 1, (0,0,0))
	textrect = text.get_rect()
	textrect.centerx, textrect.centery = area.width/2,area.height/2-100
	screen.blit(text, textrect)
	
	font = pygame.font.Font(None, 30)
	text = font.render("Start off at the store and make your way to the library by solving each problem", 1, (255,255,255))
	textrect = text.get_rect()
	textrect.centerx, textrect.centery = area.width/2,area.height/2
	screen.blit(text, textrect)
	
	font = pygame.font.Font(None, 50)
	text = font.render("Press any key to start the game.", 1, (255,255,255))
	textrect = text.get_rect()
	textrect.centerx, textrect.centery = area.width/2,area.height/2+50
	screen.blit(text, textrect)
	
	pygame.display.flip() # make everything we have drawn on the screen become visible in the window




# Main game play
while not game_over:
	# Check to see if the user has clicked the mouse or pressed a key
	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			sys.exit()
		elif event.type == pygame.MOUSEBUTTONDOWN:
			#find the next available activity (the first activity in the list that has not been completed)
			for activity in activities:
				nextactivity = activity
				if not activity.activity_completed:
					break

			#if the user has clicked on the next available activity, play it
			if nextactivity.rect.collidepoint(event.pos):
				nextactivity.play()

	game_over = True 
	for activity in activities: 
		if not activity.activity_completed:
			game_over = False

	# Draw everything to the screen
	screen.blit(background,(0,0))
	activities.draw(screen)
	pygame.display.flip()

# Display game over screen
while True:
	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			sys.exit() # if the user closed the window, quit the game
		
	# Draw everything to the screen
	screen.blit(background, (0, 0))	# draw over everything on the screen now by re-drawing the background

	winscreen,winscreen_rect = load_image("calc.bmp")
	screen.blit(winscreen,winscreen_rect)
	
	pygame.display.flip() # make everything we have drawn on the screen become visible in the window
